local leadWire = ...

-- Create default building part registering function 
function registerDefaultBuildingPart(_nodePrefix)
	leadWire:register({
		DataType = "BUILDING_PART",
		Id = _nodePrefix .. "_PART",
		ConstructorData = {
                     DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
                     CoreObjectPrefab = _nodePrefix .. "_PREFAB"
                },
                IsVisibleWhenBuilt = false -- currently doesn't work yet
	})
end

-- Apply building asset processor
    leadWire:registerAssetProcessor("models/utility/leadWire.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
    })

-- Register the LEAD_WIRE_TOP
    leadWire:registerAssetId("models/utility/leadWire.fbx/Prefab/leadWire/step_3_TopPart", _PrefixAsset .. "_LEAD_WIRE_TOP_PREFAB")
    registerDefaultBuildingPart(_PrefixAsset .. "_LEAD_WIRE_TOP")

-- Register the lead wire part
    leadWire:register({
	DataType = "BUILDING_PART",
	Id = _PrefixAsset .. "_LEAD_WIRE_ROOT_PART",
	Name = _PrefixAsset .. "_LEAD_WIRE_ROOT_NAME",
	Description = _PrefixAsset .. "_LEAD_WIRE_ROOT_DESC",
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = _PrefixAsset .. "_ROOT_PREFAB",
		EndPart = _PrefixAsset .. "_LEAD_WIRE_TOP_PART",
		FillerList = {
			_PrefixAsset .. "_TILING2_PART"
                },
		BasementFillerList = {
			_PrefixAsset .. "_TILING1_PART"
         	},
		MinimumScale = 0,
		IsVertical = true
	},
        HasMaximumInstancePerBuilding = true,
        MaximumInstancePerBuilding = 1,
        IsVisibleWhenBuilt = false,
        -- workaround to be able to select the monument decoration and delete it
	AssetBuildingFunction = _PrefixAsset .. "_LEAD_WIRE_FUNCTION"
    })

    leadWire:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = _PrefixAsset .. "_LEAD_WIRE_FUNCTION",
		WorkerCapacity = 1,
                RelatedJob = { Job = "BUILDER", Behavior = "BEHAVIOR_WORK" } -- mandatory
    })

    --------------------------------------------------------------------------
    -- Register LEAD_WIRE_COMP component
    leadWire:registerPrefabComponent("models/utility/leadWire.fbx/Prefab/leadWire/step_3_TopPart", {
	DataType = _PrefixAsset .. "_LEAD_WIRE_COMP",
	Enabled = true
    })

